package sca.component.mediation.java;

import commonj.sdo.DataObject;
import java.util.List;
import com.ibm.websphere.sca.ServiceManager;
import com.ibm.websphere.bo.BOFactory;
import java.util.ArrayList;
import java.util.Vector;
import javax.xml.namespace.QName;
import com.ibm.websphere.sibx.smobo.ServiceMessageObjectFactory;
import com.ibm.websphere.sibx.smobo.ServiceMessageObject;
import com.ibm.websphere.sca.Service;
import com.ibm.iif.mediation.XMLParser;
import com.ibm.iif.mediation.TagDO;
import com.ibm.iif.mediation.PropertyLoader;
import java.text.SimpleDateFormat;
import java.util.Date;
import java.util.TimeZone;
import com.ibm.wsspi.sibx.mediation.InputTerminal;
import com.ibm.wsspi.sibx.mediation.MediationBusinessException;
import com.ibm.wsspi.sibx.mediation.MediationConfigurationException;
import com.ibm.wsspi.sibx.mediation.OutputTerminal;
import com.ibm.wsspi.sibx.mediation.esb.ESBMediationPrimitive;
import com.ibm.wsspi.sibx.mediation.MediationServices;

/**
 * @generated
 *  Flow: IndFrwksHSDAMediation_MSSQL Interface: IIFMAHSDAAdapter Operation: write Type: request Custom Mediation: CustomMediation1
 */
public class Custom1283873651515 extends ESBMediationPrimitive {

	private InputTerminal in;
	private OutputTerminal out;

	/* state of primitive initialization */
	private boolean __initPassed = false;

	/* primitive display name */
	private String __primitiveDisplayName = null;

	/* 
	 * @generated
	 * (non-Javadoc)
	 * @see com.ibm.wsspi.sibx.mediation.Mediation#init()
	 */
	public void init() throws MediationConfigurationException {
		/* Get the mediation service */
		MediationServices mediationServices = this.getMediationServices();
		if (mediationServices == null)
			throw new MediationConfigurationException(
					"MediationServices object not set.");

		/* Get the primitive display name for use in exception messages */
		__primitiveDisplayName = mediationServices.getMediationDisplayName();

		in = mediationServices.getInputTerminal("in");
		if (in == null) {
			throw new MediationConfigurationException(
					"No terminal named in defined for mediation primitive "
							+ __primitiveDisplayName);
		}

		out = mediationServices.getOutputTerminal("out");
		if (out == null) {
			throw new MediationConfigurationException(
					"No terminal named out defined for mediation primitive "
							+ __primitiveDisplayName);
		}

		/* Initialization completed */
		__initPassed = true;
	}

	/* 
	 * @generated
	 * (non-Javadoc)
	 * @see com.ibm.wsspi.sibx.mediation.Mediation#mediate(com.ibm.wsspi.sibx.mediation.InputTerminal, commonj.sdo.DataObject)
	 */
	public void mediate(InputTerminal inputTerminal, DataObject message)
			throws MediationConfigurationException, MediationBusinessException {
		/* If initialization didn't complete, try again */
		if (!__initPassed) {
			init();
		}

		try {
			doMediate(inputTerminal, (ServiceMessageObject) message);
		} catch (Exception e) {
			if (e instanceof MediationBusinessException) {
				throw (MediationBusinessException) e;
			} else if (e instanceof MediationConfigurationException) {
				throw (MediationConfigurationException) e;
			} else {
				throw new MediationBusinessException(e);
			}
		}
	}

	/**
	 * @generated
	 */
	public void doMediate(InputTerminal inputTerminal, ServiceMessageObject smo)
			throws MediationConfigurationException, MediationBusinessException {
		/**
		 * GENERATED COMMENT - DO NOT MODIFY
		 * Variables:  for output terminals - out (com.ibm.wsspi.sibx.mediation.OutputTerminal)
		 *             for user properties - <No user properties defined>
		 * Inputs:     inputTerminal (com.ibm.wsspi.sibx.mediation.InputTerminal), smo (com.ibm.websphere.sibx.smobo.ServiceMessageObject)
		 * Exceptions: com.ibm.wsspi.sibx.mediation.MediationConfigurationException, com.ibm.wsspi.sibx.mediation.MediationBusinessException
		 */
		DataObject requestObject = (DataObject) smo;
		DataObject writeHSDAIn = ((DataObject) smo).getDataObject("body")
				.getDataObject("write").getDataObject("writeIn");
		String itemId = writeHSDAIn.getString("itemId");
		String quality = writeHSDAIn.getString("quality");
		String value = writeHSDAIn.getDataObject("value").getString("value");
		System.out.println("Updating " + itemId + " with value: " + value);
		//Prepare output
		ServiceManager serviceManager = new ServiceManager();
		BOFactory boFactory = (BOFactory) serviceManager
				.locateService("com/ibm/websphere/bo/BOFactory");
		QName qName = new QName("http://MAAdapterLib/IIFMAHSDAAdapter",
				"writeResponseMsg");
		ServiceMessageObjectFactory smoFactory = ServiceMessageObjectFactory.eINSTANCE;
		ServiceMessageObject responseSMO = smoFactory
				.createServiceMessageObject(qName);

		DataObject writeResponse = boFactory.createByElement(
				"http://MAAdapterLib/IIFMAHSDAAdapter", "writeResponse");
		//DataObject writeOutObj = writeResponse.createDataObject("success");

		Vector readOutItems = new Vector();

		String tagId = null;
		String tableName = null;
		String colmnName = null;

		String values[] = itemId.split("##");
		if (values.length >= 3) {
			tagId = values[0];
			tableName = values[1];
			colmnName = values[2];
		}

		if (tableName != null && colmnName != null) {
			String operationName = "executesetRealValueFor"
					+ tableName.toUpperCase() + "_" + colmnName.toUpperCase()
					+ "BG";
			String dataObj = "executesetRealValueFor" + tableName.toUpperCase()
					+ "_" + colmnName.toUpperCase() + "BGOutput";
			String listVal = "setRealValueFor" + tableName.toUpperCase() + "_"
					+ colmnName.toUpperCase();

			//Calendar calendar = Calendar.getInstance();
			//Date currentdate = calendar.getTime();
			//Timestamp currentTimestamp = new Timestamp(currentdate.getTime());
			PropertyLoader propertyLoader = new PropertyLoader();
			//String timestamp=propertyLoader.convertDate2Format(currentTimestamp.toLocaleString(),"yyyy-MM-dd HH:mm:ss.SSS",propertyLoader.getTimeFormat());

			SimpleDateFormat currentdateFormat = new SimpleDateFormat(
					propertyLoader.getTimeFormat());
			currentdateFormat.setTimeZone(TimeZone.getTimeZone(propertyLoader
					.getTimeZone()));
			String timestamp = currentdateFormat.format(new Date());
			DataObject csInputObj = (DataObject) boFactory.create(
					"http://www.ibm.com/xmlns/prod/websphere/j2ca/jdbc/"
							+ listVal.toLowerCase(), listVal);
			csInputObj.setString("statement1parameter1", tagId);
			csInputObj.setString("statement1parameter2", value);
			csInputObj.setString("statement1parameter3", timestamp);
			csInputObj.setString("statement1parameter4", quality);
			String[] defaultValues = propertyLoader
					.getDefaultValuesWithoutMeasurementColumn(colmnName);
			for (int dvcount = 0; dvcount < defaultValues.length; dvcount++) {
				csInputObj.setString("statement1parameter" + (dvcount + 5),
						defaultValues[dvcount]);
			}

			Service csService = (Service) ServiceManager.INSTANCE
					.locateService("HSDAJDBCOutboundInterfaceForMSSQLPartner");
			DataObject csResponse = (DataObject) csService.invoke(
					operationName, csInputObj);
			//List list=csResponse.getDataObject(dataObj).getList(listVal);

			//DataObject resultObj=(DataObject)list.get(0);
			//int resultInt=resultObj.getInt("statement1status");
			writeResponse.setBoolean("success", true);
		} else {
			System.out.println("Invalid tableName or columnName in tag");
			writeResponse.setBoolean("success", false);
		}
		((DataObject) responseSMO.getBody()).set(0, writeResponse);
		out.fire(responseSMO);
	}
}
