package sca.component.mediation.java;

import commonj.sdo.DataObject;
import java.util.List;
import com.ibm.websphere.sca.ServiceManager;
import com.ibm.websphere.bo.BOFactory;
import java.util.ArrayList;
import java.util.Vector;
import javax.xml.namespace.QName;
import com.ibm.websphere.sibx.smobo.ServiceMessageObjectFactory;
import com.ibm.websphere.sibx.smobo.ServiceMessageObject;
import com.ibm.websphere.sca.Service;
import com.ibm.iif.mediation.XMLParser;
import com.ibm.iif.mediation.TagDO;
import com.ibm.iif.mediation.PropertyLoader;
import java.text.SimpleDateFormat;
import java.util.Date;
import java.util.TimeZone;
import com.ibm.wsspi.sibx.mediation.InputTerminal;
import com.ibm.wsspi.sibx.mediation.MediationBusinessException;
import com.ibm.wsspi.sibx.mediation.MediationConfigurationException;
import com.ibm.wsspi.sibx.mediation.OutputTerminal;
import com.ibm.wsspi.sibx.mediation.esb.ESBMediationPrimitive;
import com.ibm.wsspi.sibx.mediation.MediationServices;

/**
 * @generated
 *  Flow: MATSDAMediation Interface: IIFMATSDAAdapter Operation: writeHistorical Type: request Custom Mediation: updateHistorical
 */
public class Custom1287507588265 extends ESBMediationPrimitive {

	private InputTerminal in;
	private OutputTerminal out;

	/* state of primitive initialization */
	private boolean __initPassed = false;

	/* primitive display name */
	private String __primitiveDisplayName = null;

	/* 
	 * @generated
	 * (non-Javadoc)
	 * @see com.ibm.wsspi.sibx.mediation.Mediation#init()
	 */
	public void init() throws MediationConfigurationException {
		/* Get the mediation service */
		MediationServices mediationServices = this.getMediationServices();
		if (mediationServices == null)
			throw new MediationConfigurationException(
					"MediationServices object not set.");

		/* Get the primitive display name for use in exception messages */
		__primitiveDisplayName = mediationServices.getMediationDisplayName();

		in = mediationServices.getInputTerminal("in");
		if (in == null) {
			throw new MediationConfigurationException(
					"No terminal named in defined for mediation primitive "
							+ __primitiveDisplayName);
		}

		out = mediationServices.getOutputTerminal("out");
		if (out == null) {
			throw new MediationConfigurationException(
					"No terminal named out defined for mediation primitive "
							+ __primitiveDisplayName);
		}

		/* Initialization completed */
		__initPassed = true;
	}

	/* 
	 * @generated
	 * (non-Javadoc)
	 * @see com.ibm.wsspi.sibx.mediation.Mediation#mediate(com.ibm.wsspi.sibx.mediation.InputTerminal, commonj.sdo.DataObject)
	 */
	public void mediate(InputTerminal inputTerminal, DataObject message)
			throws MediationConfigurationException, MediationBusinessException {
		/* If initialization didn't complete, try again */
		if (!__initPassed) {
			init();
		}

		try {
			doMediate(inputTerminal, (ServiceMessageObject) message);
		} catch (Exception e) {
			if (e instanceof MediationBusinessException) {
				throw (MediationBusinessException) e;
			} else if (e instanceof MediationConfigurationException) {
				throw (MediationConfigurationException) e;
			} else {
				throw new MediationBusinessException(e);
			}
		}
	}

	/**
	 * @generated
	 */
	public void doMediate(InputTerminal inputTerminal, ServiceMessageObject smo)
			throws MediationConfigurationException, MediationBusinessException {
		/**
		 * GENERATED COMMENT - DO NOT MODIFY
		 * Variables:  for output terminals - out (com.ibm.wsspi.sibx.mediation.OutputTerminal)
		 *             for user properties - <No user properties defined>
		 * Inputs:     inputTerminal (com.ibm.wsspi.sibx.mediation.InputTerminal), smo (com.ibm.websphere.sibx.smobo.ServiceMessageObject)
		 * Exceptions: com.ibm.wsspi.sibx.mediation.MediationConfigurationException, com.ibm.wsspi.sibx.mediation.MediationBusinessException
		 */
		DataObject requestObject = (DataObject) smo;
		DataObject writeTSDAIn = ((DataObject) smo).getDataObject("body")
				.getDataObject("writeHistorical").getDataObject("writeIn");
		String itemId = writeTSDAIn.getString("itemIds");
		String quality = writeTSDAIn.getString("quality");
		String timestamp = writeTSDAIn.getString("timestamp");
		String value = writeTSDAIn.getDataObject("value").getString("value");

		//Prepare output
		ServiceManager serviceManager = new ServiceManager();
		BOFactory boFactory = (BOFactory) serviceManager
				.locateService("com/ibm/websphere/bo/BOFactory");
		QName qName = new QName("http://MAAdapterLib/IIFMATSDAAdapter",
				"writeHistoricalResponseMsg");
		ServiceMessageObjectFactory smoFactory = ServiceMessageObjectFactory.eINSTANCE;
		ServiceMessageObject responseSMO = smoFactory
				.createServiceMessageObject(qName);

		DataObject writeResponse = boFactory.createByElement(
				"http://MAAdapterLib/IIFMATSDAAdapter",
				"writeHistoricalResponse");

		Vector readOutItems = new Vector();

		String tagId = null;
		String tableName = null;
		String colmnName = null;

		String values[] = itemId.split("##");
		if (values.length >= 3) {
			tagId = values[0];
			tableName = values[1];
			colmnName = values[2];
		}

		String operationName = "executeupdateHistoricalValueFor"
				+ tableName.toUpperCase() + "_" + colmnName.toUpperCase()
				+ "BG";
		String dataObj = "executeupdateHistoricalValueFor"
				+ tableName.toUpperCase() + "_" + colmnName.toUpperCase()
				+ "BGOutput";
		String listVal = "updateHistoricalValueFor" + tableName.toUpperCase()
				+ "_" + colmnName.toUpperCase();

		DataObject csInputObj = (DataObject) boFactory.create(
				"http://www.ibm.com/xmlns/prod/websphere/j2ca/jdbc/"
						+ listVal.toLowerCase(), listVal);
		csInputObj.setString("statement1parameter1", value);
		csInputObj.setString("statement1parameter2", quality);
		csInputObj.setString("statement1parameter3", tagId);
		csInputObj.setString("statement1parameter4", timestamp);
		Service csService = (Service) ServiceManager.INSTANCE
				.locateService("JDBCOutboundInterfaceForOraclePartner");
		DataObject csResponse = (DataObject) csService.invoke(operationName,
				csInputObj);
		//List list=csResponse.getDataObject(dataObj).getList(listVal);

		//DataObject resultObj=(DataObject)list.get(0);
		//int resultInt=resultObj.getInt("statement1status");
		writeResponse.setBoolean("success", true);

		((DataObject) responseSMO.getBody()).set(0, writeResponse);
		out.fire(responseSMO);
	}
}
