package com.ibm.iif.mediation;

import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.Date;
import java.util.HashMap;
import java.util.Map;
import java.util.ResourceBundle;

public class PropertyLoader {
	private String query = null;
	private String columnNames = null;
	private String whereClause = null;
	private String timeFormat = null;
	private String timeZone = null;
	private Map defaultValues=null;
	private String defaultValueString=null;

	public PropertyLoader() {
		// TODO Auto-generated constructor stub
		loadProperty();
	}

	public void loadProperty() {
		ResourceBundle bundle = ResourceBundle.getBundle("Datasource");
		query = bundle.getString("query");
		columnNames = bundle.getString("columnNames");
		whereClause = bundle.getString("whereClause");
		timeFormat = bundle.getString("timeFormat");
		timeZone = bundle.getString("timeZone");
		defaultValueString=bundle.getString("defaultValues");
	}

	public String getTableName() {
		String tableName = null;
		int fromIndex = query.indexOf("from");
		int whereIndex = query.indexOf("where");
		if (whereIndex != -1)
			tableName = query.substring(fromIndex + 4, whereIndex);
		else
			tableName = query.substring(fromIndex + 5);
		tableName = tableName.substring(tableName.indexOf(".") + 1);

		System.out.println("TableName--" + tableName + "--");

		return tableName.trim().toUpperCase();
	}

	public String[] getColumnNames() {
		String[] columnNameArr = null;
		columnNameArr = columnNames.split(",");
		return columnNameArr;
	}

	public String getWhereClause() {
		return whereClause;

	}

	public static void main(String[] args) {
		PropertyLoader propLoadre = new PropertyLoader();
		// System.out.println(propLoadre.getTableName());
		// System.out.println(propLoadre.getColumnNames());
		// System.out.println(propLoadre.convertDate2Format("2009-12-20 13:30:30",
		// "yyyy-MM-dd HH:mm:ss", "dd/MM/yyyy HH:mm"));
		System.out.println(propLoadre.convertDate2Format("2008-08-31 00:00:00.0",
				"yyyy-MM-dd HH:mm:ss", "yyyy-MM-dd HH:mm:ss"));
//		System.out.println(propLoadre.convertDate2Format("2008-08-31 00:00:00.0",
//				"dd-MMM-yyyy", "yyyy-MM-dd HH:mm:ss"));
//		System.out.println(propLoadre.convertDate2Format("31-Aug-2008",
//				"dd-MMM-yyyy", "yyyy-MM-dd HH:mm:ss"));
		// SimpleDateFormat currentdateFormat = new
		// SimpleDateFormat("yyyy-MM-dd HH:mm:ss");
		// currentdateFormat.setTimeZone(TimeZone.getTimeZone("EST"));
		// String timestamp=currentdateFormat.format( new Date() );
		// System.out.println("Timestamp "+timestamp);

	}

	public String convertDate2Format(String localtime, String fromFormat,
			String toFormat) {
		System.out.println("In convertDate2Format - localtime: " + localtime
				+ ", fromformat: " + fromFormat + ", toformat: " + toFormat);
		SimpleDateFormat fromDft = new SimpleDateFormat();
		fromDft.applyPattern(fromFormat);
		Date localDate = null;
		try {
			localDate = fromDft.parse(localtime);
		} catch (ParseException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		SimpleDateFormat toDft = new SimpleDateFormat();
		toDft.applyPattern(toFormat);
		String convertedTime = toDft.format(localDate);
		System.out.println("Converted Time: " + convertedTime);
		return convertedTime;
	}

	public String getTimeFormat() {
		return timeFormat;
	}

	public void setTimeFormat(String timeFormat) {
		this.timeFormat = timeFormat;
	}

	public String getTimeZone() {
		return timeZone;
	}

	public void setTimeZone(String timeZone) {
		this.timeZone = timeZone;
	}

	public Map getDefaultValues() {
		return defaultValues;
	}

public String[] getDefaultValuesWithoutMeasurementColumn(String column) {
		
		String[] columnPair=defaultValueString.split(",");
		String[] defaultValuesWithoutColumn=new String[columnPair.length-1];
		for(int columnCount=0,dfCount=0;columnCount<columnPair.length;columnCount++){
			String[] eachColumn=columnPair[columnCount].split(":_:");
			if(eachColumn.length==2){
				if(!eachColumn[0].equalsIgnoreCase(column)){
					defaultValuesWithoutColumn[dfCount]=eachColumn[1];
					dfCount++;
				}
			}else{
				System.out.println("Invalid default Value Pair");
			}
		}
		return defaultValuesWithoutColumn;
	}
	public void setDefaultValues(String defaultValueString) {
		defaultValues=new HashMap<String, String>();
		String[] columnPair=defaultValueString.split(",");
		for(int columnCount=0;columnCount<columnPair.length;columnCount++){
			String[] eachColumn=columnPair[columnCount].split(":_:");
			if(eachColumn.length==2){
				defaultValues.put(eachColumn[0],eachColumn[1]);
			}else{
				System.out.println("Invalid default Value Pair");
			}
		}
		
	}

}
