package sca.component.mediation.java;

import commonj.sdo.DataObject;
import java.util.List;
import com.ibm.websphere.sca.ServiceManager;
import com.ibm.websphere.bo.BOFactory;
import java.util.ArrayList;
import java.util.Vector;
import javax.xml.namespace.QName;
import com.ibm.websphere.sibx.smobo.ServiceMessageObjectFactory;
import com.ibm.websphere.sibx.smobo.ServiceMessageObject;
import com.ibm.websphere.sca.Service;
import com.ibm.iif.mediation.XMLParser;
import com.ibm.iif.mediation.TagDO;
import com.ibm.iif.mediation.PropertyLoader;
import com.ibm.wsspi.sibx.mediation.InputTerminal;
import com.ibm.wsspi.sibx.mediation.MediationBusinessException;
import com.ibm.wsspi.sibx.mediation.MediationConfigurationException;
import com.ibm.wsspi.sibx.mediation.OutputTerminal;
import com.ibm.wsspi.sibx.mediation.esb.ESBMediationPrimitive;
import com.ibm.wsspi.sibx.mediation.MediationServices;

/**
 * @generated
 *  Flow: IndFrwksTSDAMediation_DB2 Interface: IIFMATSDAAdapter Operation: readHistorical Type: request Custom Mediation: CustomMediation1
 */
public class Custom1280473370171 extends ESBMediationPrimitive {

	private InputTerminal in;
	private OutputTerminal out;

	/* state of primitive initialization */
	private boolean __initPassed = false;

	/* primitive display name */
	private String __primitiveDisplayName = null;

	/* 
	 * @generated
	 * (non-Javadoc)
	 * @see com.ibm.wsspi.sibx.mediation.Mediation#init()
	 */
	public void init() throws MediationConfigurationException {
		/* Get the mediation service */
		MediationServices mediationServices = this.getMediationServices();
		if (mediationServices == null)
			throw new MediationConfigurationException(
					"MediationServices object not set.");

		/* Get the primitive display name for use in exception messages */
		__primitiveDisplayName = mediationServices.getMediationDisplayName();

		in = mediationServices.getInputTerminal("in");
		if (in == null) {
			throw new MediationConfigurationException(
					"No terminal named in defined for mediation primitive "
							+ __primitiveDisplayName);
		}

		out = mediationServices.getOutputTerminal("out");
		if (out == null) {
			throw new MediationConfigurationException(
					"No terminal named out defined for mediation primitive "
							+ __primitiveDisplayName);
		}

		/* Initialization completed */
		__initPassed = true;
	}

	/* 
	 * @generated
	 * (non-Javadoc)
	 * @see com.ibm.wsspi.sibx.mediation.Mediation#mediate(com.ibm.wsspi.sibx.mediation.InputTerminal, commonj.sdo.DataObject)
	 */
	public void mediate(InputTerminal inputTerminal, DataObject message)
			throws MediationConfigurationException, MediationBusinessException {
		/* If initialization didn't complete, try again */
		if (!__initPassed) {
			init();
		}

		try {
			doMediate(inputTerminal, (ServiceMessageObject) message);
		} catch (Exception e) {
			if (e instanceof MediationBusinessException) {
				throw (MediationBusinessException) e;
			} else if (e instanceof MediationConfigurationException) {
				throw (MediationConfigurationException) e;
			} else {
				throw new MediationBusinessException(e);
			}
		}
	}

	/**
	 * @generated
	 */
	public void doMediate(InputTerminal inputTerminal, ServiceMessageObject smo)
			throws MediationConfigurationException, MediationBusinessException {
		/**
		 * GENERATED COMMENT - DO NOT MODIFY
		 * Variables:  for output terminals - out (com.ibm.wsspi.sibx.mediation.OutputTerminal)
		 *             for user properties - <No user properties defined>
		 * Inputs:     inputTerminal (com.ibm.wsspi.sibx.mediation.InputTerminal), smo (com.ibm.websphere.sibx.smobo.ServiceMessageObject)
		 * Exceptions: com.ibm.wsspi.sibx.mediation.MediationConfigurationException, com.ibm.wsspi.sibx.mediation.MediationBusinessException
		 */
		DataObject requestObject = (DataObject) smo;
		DataObject readTSDAIn = ((DataObject) smo).getDataObject("body")
				.getDataObject("readHistorical").getDataObject("readTSDAIn");
		String startDate = readTSDAIn.getString("startDate");
		String endDate = readTSDAIn.getString("endDate");
		boolean bounds = readTSDAIn.getBoolean("bounds");
		List itemIds = readTSDAIn.getDataObject("itemIds").getList("ItemIds");
		System.out.println(startDate);
		System.out.println(endDate);
		System.out.println(bounds);
		System.out.println(itemIds.get(0));
		//Prepare output
		ServiceManager serviceManager = new ServiceManager();
		BOFactory boFactory = (BOFactory) serviceManager
				.locateService("com/ibm/websphere/bo/BOFactory");
		//DataObject readOutObj=(DataObject)boFactory.create("http://MAAdapterLib","ReadTSDAOut");
		QName qName = new QName("http://MAAdapterLib/IIFMATSDAAdapter",
				"readHistoricalResponseMsg");
		ServiceMessageObjectFactory smoFactory = ServiceMessageObjectFactory.eINSTANCE;
		ServiceMessageObject responseSMO = smoFactory
				.createServiceMessageObject(qName);

		DataObject readHistoricalResponse = boFactory.createByElement(
				"http://MAAdapterLib/IIFMATSDAAdapter",
				"readHistoricalResponse");
		DataObject readOutObj = readHistoricalResponse
				.createDataObject("readTSDAOut");

		Vector readOutItems = new Vector();

		for (int i = 0; i < itemIds.size(); i++) {
			//For each itemId
			//Parse XML
			//XMLParser xmlparser=new XMLParser();
			//TagDO tagDO=xmlparser.getTagDO("6410/12-1_BOTTOM_HOLE_PRESSURE");
			//TagDO tagDO=xmlparser.getTagDO(String.valueOf(itemIds.get(i)));
			//System.out.println("TagDO "+tagDO);
			String tagId = null;
			String tableName = null;
			String colmnName = null;

			String values[] = ((String) itemIds.get(i)).split("##");
			if (values.length >= 3) {
				tagId = values[0];
				tableName = values[1];
				colmnName = values[2];
			}

			PropertyLoader propertyLoader = new PropertyLoader();
			String whereCls = propertyLoader.getWhereClause();
			whereCls = "where " + whereCls;
			//Prepare request msg

			//Call Service
			//String colmnName=tagDO.getColumnName();
			//String tableName=tagDO.getTableName();
			//Need to comment this later
			//tableName="TABLE";
			//colmnName="COLUMN";

			//End of hard coding
			//String whereCls="where "+tagDO.getWhereClause();
			whereCls = whereCls.replace("$$TAG$$", tagId);
			//String changedStartDate=propertyLoader.convertDate2Format(startDate,"yyyy-MM-dd HH:mm:ss",propertyLoader.getTimeFormat());
			//String changedEndDate=propertyLoader.convertDate2Format(endDate,"yyyy-MM-dd HH:mm:ss",propertyLoader.getTimeFormat());

			whereCls = whereCls.replace("$$STARTDATE$$", startDate);
			whereCls = whereCls.replace("$$ENDDATE$$", endDate);

			//whereCls=whereCls.replace("$$STARTDATE$$",startDate);
			//whereCls=whereCls.replace("$$ENDDATE$$",endDate);
			System.out.println("Wherecls " + whereCls);

			String operationName = "retrieveallgetHistoricalValueFor"
					+ tableName.toUpperCase() + "_" + colmnName.toUpperCase()
					+ "BG";
			String dataObj = "retrieveallgetHistoricalValueFor"
					+ tableName.toUpperCase() + "_" + colmnName.toUpperCase()
					+ "BGOutput";
			String listVal = "getHistoricalValueFor" + tableName.toUpperCase()
					+ "_" + colmnName.toUpperCase();
			Vector readItemValues = new Vector();

			DataObject csInputObj = (DataObject) boFactory.create(
					"http://www.ibm.com/xmlns/prod/websphere/j2ca/jdbc/"
							+ listVal.toLowerCase(), listVal);
			csInputObj.setString("jdbcwhereclause", whereCls);
			Service csService = (Service) ServiceManager.INSTANCE
					.locateService("JDBCOutboundInterfaceForDB2Partner");
			DataObject csResponse = (DataObject) csService.invoke(
					operationName, csInputObj);
			List list = csResponse.getDataObject(dataObj).getList(listVal);
			for (int valueCnt = 0; valueCnt < list.size(); valueCnt++) {
				DataObject waterCutObj = (DataObject) list.get(valueCnt);
				DataObject simpleTypeValueObj = (DataObject) boFactory.create(
						"http://MAAdapterLib", "SimpleTypeValue");
				simpleTypeValueObj.set("value", waterCutObj
						.getString("water_cut"));
				DataObject readItemValueObj = (DataObject) boFactory.create(
						"http://MAAdapterLib", "ReadItemValues");
				readItemValueObj.set("value", simpleTypeValueObj);
				String timestamp = waterCutObj.getString("timestamp");
				String quality = waterCutObj.getString("quality");
				//String changedTime=propertyLoader.convertDate2Format(timestamp,propertyLoader.getTimeFormat(),"yyyy-MM-dd HH:mm:ss");

				readItemValueObj.setString("timestamp", timestamp);

				//readItemValueObj.setString("timestamp",waterCutObj.getString("timestamp"));
				readItemValueObj.setString("quality", quality);
				readItemValues.add(readItemValueObj);
			}
			//Parse response msg

			//Prepare output msg

			//Add it to output

			DataObject readOutItemObj = (DataObject) boFactory.create(
					"http://MAAdapterLib", "ReadOutItem");
			readOutItemObj.set("itemId", itemIds.get(i));
			readOutItemObj.setString("dataType", "String");
			readOutItemObj.setString("uom", "");
			readOutItemObj.setList("readItemValues", readItemValues);
			readOutItems.add(readOutItemObj);

		}

		//DataObject readTSDAOutItem=(DataObject)boFactory.create("http://MAAdapterLib","ReadTSDAOutItem");
		//readTSDAOutItem.setList("itemList",readOutItems);
		readOutObj.setList("itemList", readOutItems);
		//smo.set("body",readOutObj);
		//responseSMO.setBody(readHistoricalResponse);
		((DataObject) responseSMO.getBody()).set(0, readHistoricalResponse);
		out.fire(responseSMO);
	}
}
